Index: trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90	(revision 3083)
@@ -1,10 +1,10 @@
       subroutine callcorrk(ngrid,nlayer,pq,nq,qsurf,zday,      &
-          albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,    & 
-          tsurf,fract,dist_star,                               &
+          albedo,albedo_equivalent,emis,mu0,pplev,pplay,zzlev, &
+          pt,tsurf,fract,dist_star,                            &
           dtlw,dtsw,fluxsurf_lw,                               &
           fluxsurf_sw,fluxsurfabs_sw,fluxtop_lw,               &
           fluxabs_sw,fluxtop_dn,                               &
           OLR_nu,OSR_nu,                                       &
-          int_dtaui,int_dtauv,                                 &
+          int_dtaui,int_dtauv,popthi,popthv,poptci,poptcv,     &
           lastcall)
 
@@ -18,5 +18,5 @@
       use callkeys_mod, only: diurnal,tracer,seashaze,corrk_recombin,   &
                               strictboundcorrk,specOLR,diagdtau,        &
-                              tplanckmin,tplanckmax
+                              tplanckmin,tplanckmax,callclouds,Fcloudy
       use geometry_mod, only: latitude
 
@@ -36,4 +36,5 @@
 !     Robin Wordsworth (2009)
 !     Jan Vatant d'Ollone (2018) -> corrk recombining case
+!     Bruno de Batz de Trenquelléon (2023) --> Optics of Titan's haze and coulds
 !
 !==================================================================
@@ -58,4 +59,5 @@
       REAL,INTENT(IN) :: pplev(ngrid,nlayer+1)     ! Inter-layer pressure (Pa).
       REAL,INTENT(IN) :: pplay(ngrid,nlayer)       ! Mid-layer pressure (Pa).
+      REAL,INTENT(IN) :: zzlev(ngrid,nlayer+1)     ! Altitude at the atmospheric layer boundaries (ref : local surf).
       REAL,INTENT(IN) :: pt(ngrid,nlayer)          ! Air temperature (K).
       REAL,INTENT(IN) :: tsurf(ngrid)              ! Surface temperature (K).
@@ -76,6 +78,11 @@
       REAL,INTENT(OUT) :: OSR_nu(ngrid,L_NSPECTV)        ! Outgoing SW radition in each band (Normalized to the band width (W/m2/cm-1).
       REAL,INTENT(OUT) :: albedo_equivalent(ngrid)       ! Spectrally Integrated Albedo. For Diagnostic. By MT2015
-      REAL,INTENT(OUT) :: int_dtaui(ngrid,nlayer,L_NSPECTI) ! VI optical thickness of layers within narrowbands for diags ().
-      REAL,INTENT(OUT) :: int_dtauv(ngrid,nlayer,L_NSPECTV) ! IR optical thickness of layers within narrowbands for diags ().
+      REAL,INTENT(OUT) :: int_dtaui(ngrid,nlayer,L_NSPECTI) ! IR optical thickness of layers within narrowbands for diags ().
+      REAL,INTENT(OUT) :: int_dtauv(ngrid,nlayer,L_NSPECTV) ! VI optical thickness of layers within narrowbands for diags ().
+      REAL,INTENT(OUT) :: popthv(ngrid,nlayer,L_NSPECTV,5)  ! VI optical properties of haze within narrowbands (dtau,tau,k,w,g).
+      REAL,INTENT(OUT) :: poptcv(ngrid,nlayer,L_NSPECTV,5)  ! VI optical properties of haze and clouds within narrowbands (dtau,tau,k,w,g).
+      REAL,INTENT(OUT) :: popthi(ngrid,nlayer,L_NSPECTI,5)  ! IR optical properties of haze within narrowbands (dtau,tau,k,w,g).
+      REAL,INTENT(OUT) :: poptci(ngrid,nlayer,L_NSPECTI,5)  ! IR optical properties of haze and clouds within narrowbands (dtau,tau,k,w,g).
+      
       
       
@@ -90,13 +97,50 @@
       ! Optical values for the optci/cv subroutines
       REAL*8 stel(L_NSPECTV),stel_fract(L_NSPECTV)
+      
       REAL*8 dtaui(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 dtaui_cc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 dtaui_dc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
       REAL*8 dtauv(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 dtauv_cc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 dtauv_dc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      
       REAL*8 cosbv(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 cosbv_cc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 cosbv_dc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
       REAL*8 cosbi(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 cosbi_cc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 cosbi_dc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      
       REAL*8 wbari(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 wbari_cc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
+      REAL*8 wbari_dc(L_NLAYRAD,L_NSPECTI,L_NGAUSS)
       REAL*8 wbarv(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 wbarv_cc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 wbarv_dc(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      
       REAL*8 tauv(L_NLEVRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 tauv_cc(L_NLEVRAD,L_NSPECTV,L_NGAUSS)
+      REAL*8 tauv_dc(L_NLEVRAD,L_NSPECTV,L_NGAUSS)
+      
       REAL*8 taucumv(L_LEVELS,L_NSPECTV,L_NGAUSS)
+      REAL*8 taucumv_cc(L_LEVELS,L_NSPECTV,L_NGAUSS)
+      REAL*8 taucumv_dc(L_LEVELS,L_NSPECTV,L_NGAUSS)
       REAL*8 taucumi(L_LEVELS,L_NSPECTI,L_NGAUSS)
+      REAL*8 taucumi_cc(L_LEVELS,L_NSPECTI,L_NGAUSS)
+      REAL*8 taucumi_dc(L_LEVELS,L_NSPECTI,L_NGAUSS)
+      
+      REAL*8 popt_hazev(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_hazev_cc(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_hazev_dc(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_hazei(L_LEVELS,L_NSPECTI,3)
+      REAL*8 popt_hazei_cc(L_LEVELS,L_NSPECTI,3)
+      REAL*8 popt_hazei_dc(L_LEVELS,L_NSPECTI,3)
+
+      REAL*8 popt_cloudsv(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_cloudsv_cc(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_cloudsv_dc(L_LEVELS,L_NSPECTV,3)
+      REAL*8 popt_cloudsi(L_LEVELS,L_NSPECTI,3)
+      REAL*8 popt_cloudsi_cc(L_LEVELS,L_NSPECTI,3)
+      REAL*8 popt_cloudsi_dc(L_LEVELS,L_NSPECTI,3)
 
       REAL*8 nfluxtopv,nfluxtopi,nfluxtop,fluxtopvdn
@@ -110,5 +154,5 @@
       REAL*8 albv(L_NSPECTV)                         ! Spectral Visible Albedo.
 
-      INTEGER ig,l,k,nw,iq,ip,ilay,it
+      INTEGER ig,l,k,nw,iq,ip,ilay,it,lev2lay,cdcolumn,ng
       
       LOGICAL found
@@ -449,4 +493,73 @@
 !-----------------------------------------------------------------------
 
+         ! Clear column :
+         cdcolumn = 0
+         call optcv(pqmo(ig,:,:),nlayer,zzlev(ig,:),plevrad,tmid,pmid,    &
+              dtauv_cc,tauv_cc,taucumv_cc,wbarv_cc,cosbv_cc,tauray,taugsurf,seashazefact,&
+              popt_hazev_cc,popt_cloudsv_cc,cdcolumn)
+         ! Dark column :
+         cdcolumn = 1
+         call optcv(pqmo(ig,:,:),nlayer,zzlev(ig,:),plevrad,tmid,pmid,    &
+              dtauv_dc,tauv_dc,taucumv_dc,wbarv_dc,cosbv_dc,tauray,taugsurf,seashazefact,&
+              popt_hazev_dc,popt_cloudsv_dc,cdcolumn)
+         
+         ! Mean opacity, ssa and asf :
+         where ((exp(-dtauv_cc(:,:,:)).ge.1.d-40) .and. (exp(-dtauv_dc(:,:,:)).ge.1.d-40))
+            dtauv(:,:,:) = -log((1-Fcloudy)*exp(-dtauv_cc(:,:,:)) + Fcloudy*exp(-dtauv_dc(:,:,:)))
+         elsewhere
+            dtauv(:,:,:) = dtauv_dc(:,:,:) ! No need to average...
+         endwhere
+         do ng = 1, L_NGAUSS
+            do nw = 1, L_NSPECTV
+               taucumv(1,nw,ng) = 0.0d0
+               do k = 2, L_LEVELS
+                  if ((exp(-taucumv_cc(k,nw,ng)).ge.1.d-40) .and. (exp(-taucumv_dc(k,nw,ng)).ge.1.d-40)) then
+                     taucumv(k,nw,ng) = taucumv(k-1,nw,ng) - log((1-Fcloudy)*exp(-taucumv_cc(k,nw,ng)) + Fcloudy*exp(-taucumv_dc(k,nw,ng)))
+                  else
+                     taucumv(k,nw,ng) = taucumv(k-1,nw,ng) + taucumv_dc(k,nw,ng) ! No need to average...
+                  end if
+               end do
+               do l = 1, L_NLAYRAD
+                  tauv(l,nw,ng) = taucumv(2*l,nw,ng)
+               end do
+               tauv(l,nw,ng) = taucumv(2*L_NLAYRAD+1,nw,ng)
+            end do
+         end do
+         wbarv = (dtauv_cc*wbarv_cc + dtauv_dc*wbarv_dc) / (dtauv_cc + dtauv_dc)
+         cosbv = (dtauv_cc*wbarv_cc*cosbv_cc + dtauv_dc*wbarv_dc*cosbv_dc) / (dtauv_cc*wbarv_cc + dtauv_dc*wbarv_dc)
+         
+         ! Diagnostics for haze :
+         where (popt_hazev_cc(:,:,1) .lt. 1.d-30)
+            popt_hazev_cc(:,:,1) = 1.d-30
+         endwhere
+         where (popt_hazev_dc(:,:,1) .lt. 1.d-30)
+            popt_hazev_dc(:,:,1) = 1.d-30
+         endwhere
+         popt_hazev(:,:,1) = -log( (1-Fcloudy)*exp(-popt_hazev_cc(:,:,1)) + Fcloudy*exp(-popt_hazev_dc(:,:,1)) )
+         popt_hazev(:,:,2) = ((popt_hazev_cc(:,:,1)*popt_hazev_cc(:,:,2) + popt_hazev_dc(:,:,1)*popt_hazev_dc(:,:,2)) &
+                             / (popt_hazev_cc(:,:,1) + popt_hazev_dc(:,:,1)))
+         where ((popt_hazev_cc(:,:,2).gt.0.0D0) .or. (popt_hazev_dc(:,:,2).gt.0.0D0))
+            popt_hazev(:,:,3) = (popt_hazev_cc(:,:,1)*popt_hazev_cc(:,:,2)*popt_hazev_cc(:,:,3) + popt_hazev_dc(:,:,1)*popt_hazev_dc(:,:,2)*popt_hazev_dc(:,:,3)) &
+                             / (popt_hazev_cc(:,:,1)*popt_hazev_cc(:,:,2) + popt_hazev_dc(:,:,1)*popt_hazev_dc(:,:,2))
+         elsewhere
+            popt_hazev(:,:,3) = 0.0D0
+         endwhere
+         ! Diagnostics for clouds :
+         where (popt_cloudsv_cc(:,:,1) .lt. 1.d-30)
+            popt_cloudsv_cc(:,:,1) = 1.d-30
+         endwhere
+         where (popt_cloudsv_dc(:,:,1) .lt. 1.d-30)
+            popt_cloudsv_dc(:,:,1) = 1.d-30
+         endwhere
+         popt_cloudsv(:,:,1) = -log( (1-Fcloudy)*exp(-popt_cloudsv_cc(:,:,1)) + Fcloudy*exp(-popt_cloudsv_dc(:,:,1)) )
+         popt_cloudsv(:,:,2) = ((popt_cloudsv_cc(:,:,1)*popt_cloudsv_cc(:,:,2) + popt_cloudsv_dc(:,:,1)*popt_cloudsv_dc(:,:,2)) &
+                             / (popt_cloudsv_cc(:,:,1) + popt_cloudsv_dc(:,:,1)))
+         where ((popt_cloudsv_cc(:,:,2).gt.0.0D0) .or. (popt_cloudsv_dc(:,:,2).gt.0.0D0))
+            popt_cloudsv(:,:,3) = (popt_cloudsv_cc(:,:,1)*popt_cloudsv_cc(:,:,2)*popt_cloudsv_cc(:,:,3) + popt_cloudsv_dc(:,:,1)*popt_cloudsv_dc(:,:,2)*popt_cloudsv_dc(:,:,3)) &
+                             / (popt_cloudsv_cc(:,:,1)*popt_cloudsv_cc(:,:,2) + popt_cloudsv_dc(:,:,1)*popt_cloudsv_dc(:,:,2))
+         elsewhere
+            popt_cloudsv(:,:,3) = 0.0D0
+         endwhere
+         
          if(fract(ig) .ge. 1.0e-4) then ! Only during daylight.
             if((ngrid.eq.1).and.(global1d))then
@@ -459,8 +572,4 @@
                end do
             endif
-            
-            call optcv(pqmo(ig,:,:),nlayer,plevrad,tmid,pmid,   &
-                 dtauv,tauv,taucumv,wbarv,cosbv,tauray,taugsurf,seashazefact)
-
             call sfluxv(dtauv,tauv,taucumv,albv,dwnv,wbarv,cosbv,  &
                  acosz,stel_fract,                                 &
@@ -469,8 +578,8 @@
 
          else ! During the night, fluxes = 0.
-            nfluxtopv       = 0.0d0
-            fluxtopvdn      = 0.0d0
-            nfluxoutv_nu(:) = 0.0d0
-            nfluxgndv_nu(:) = 0.0d0
+            nfluxtopv        = 0.0d0
+            fluxtopvdn       = 0.0d0
+            nfluxoutv_nu(:)  = 0.0d0
+            nfluxgndv_nu(:)  = 0.0d0
             do l=1,L_NLAYRAD
                fmnetv(l)=0.0d0
@@ -502,6 +611,74 @@
 !-----------------------------------------------------------------------
 
-         call optci(pqmo(ig,:,:),nlayer,plevrad,tlevrad,tmid,pmid,   &
-              dtaui,taucumi,cosbi,wbari,taugsurfi,seashazefact)
+
+         ! Clear column :
+         cdcolumn = 0
+         call optci(pqmo(ig,:,:),nlayer,zzlev(ig,:),plevrad,tlevrad,tmid,pmid,&
+              dtaui_cc,taucumi_cc,cosbi_cc,wbari_cc,taugsurfi,seashazefact,   &
+              popt_hazei_cc,popt_cloudsi_cc,cdcolumn)
+         ! Dark column :
+         cdcolumn = 1
+         call optci(pqmo(ig,:,:),nlayer,zzlev(ig,:),plevrad,tlevrad,tmid,pmid,&
+              dtaui_dc,taucumi_dc,cosbi_dc,wbari_dc,taugsurfi,seashazefact,   &
+              popt_hazei_dc,popt_cloudsi_dc,cdcolumn)
+
+         ! Mean opacity, ssa and asf :
+         where ((exp(-dtaui_cc(:,:,:)).ge.1.d-40) .and. (exp(-dtaui_dc(:,:,:)).ge.1.d-40))
+            dtaui(:,:,:) = -log((1-Fcloudy)*exp(-dtaui_cc(:,:,:)) + Fcloudy*exp(-dtaui_dc(:,:,:)))
+         elsewhere
+            dtaui(:,:,:) = dtaui_dc(:,:,:) ! No need to average...
+         endwhere
+         do ng = 1, L_NGAUSS
+            do nw = 1, L_NSPECTI
+               taucumi(1,nw,ng) = 0.0d0
+               do k = 2, L_LEVELS
+                  if ((exp(-taucumi_cc(k,nw,ng)).ge.1.d-40) .and. (exp(-taucumi_dc(k,nw,ng)).ge.1.d-40)) then
+                     taucumi(k,nw,ng) = taucumi(k-1,nw,ng) - log((1-Fcloudy)*exp(-taucumi_cc(k,nw,ng)) + Fcloudy*exp(-taucumi_dc(k,nw,ng)))
+                  else
+                     taucumi(k,nw,ng) = taucumi(k-1,nw,ng) + taucumi_dc(k,nw,ng) ! No need to average...
+                  end if
+               end do
+            end do
+         end do
+         where ((wbari_cc.gt.0.0D0) .or. (wbari_dc.gt.0.0D0))
+            wbari = (dtaui_cc*wbari_cc + dtaui_dc*wbari_dc) / (dtaui_cc + dtaui_dc)
+            cosbi = (dtaui_cc*wbari_cc*cosbi_cc + dtaui_dc*wbari_dc*cosbi_dc) / (dtaui_cc*wbari_cc + dtaui_dc*wbari_dc)
+         elsewhere
+            wbari = 0.0D0
+            cosbi = 0.0D0
+         endwhere
+
+         ! Diagnostics for haze :
+         where (popt_hazei_cc(:,:,1) .lt. 1.d-30)
+            popt_hazei_cc(:,:,1) = 1.d-30
+         endwhere
+         where (popt_hazei_dc(:,:,1) .lt. 1.d-30)
+            popt_hazei_dc(:,:,1) = 1.d-30
+         endwhere
+         popt_hazei(:,:,1) = -log( (1-Fcloudy)*exp(-popt_hazei_cc(:,:,1)) + Fcloudy*exp(-popt_hazei_dc(:,:,1)) )
+         popt_hazei(:,:,2) = (popt_hazei_cc(:,:,1)*popt_hazei_cc(:,:,2) + popt_hazei_dc(:,:,1)*popt_hazei_dc(:,:,2)) &
+                             / (popt_hazei_cc(:,:,1) + popt_hazei_dc(:,:,1))
+         where ((popt_hazei_cc(:,:,2).gt.0.0D0) .or. (popt_hazei_dc(:,:,2).gt.0.0D0))
+            popt_hazei(:,:,3) = (popt_hazei_cc(:,:,1)*popt_hazei_cc(:,:,2)*popt_hazei_cc(:,:,3) + popt_hazei_dc(:,:,1)*popt_hazei_dc(:,:,2)*popt_hazei_dc(:,:,3)) &
+                             / (popt_hazei_cc(:,:,1)*popt_hazei_cc(:,:,2) + popt_hazei_dc(:,:,1)*popt_hazei_dc(:,:,2))
+         elsewhere
+            popt_hazei(:,:,3) = 0.0D0
+         endwhere
+         ! Diagnostics for clouds :
+         where (popt_cloudsi_cc(:,:,1) .lt. 1.d-30)
+            popt_cloudsi_cc(:,:,1) = 1.d-30
+         endwhere
+         where (popt_cloudsi_dc(:,:,1) .lt. 1.d-30)
+            popt_cloudsi_dc(:,:,1) = 1.d-30
+         endwhere
+         popt_cloudsi(:,:,1) = -log( (1-Fcloudy)*exp(-popt_cloudsi_cc(:,:,1)) + Fcloudy*exp(-popt_cloudsi_dc(:,:,1)) )
+         popt_cloudsi(:,:,2) = ((popt_cloudsi_cc(:,:,1)*popt_cloudsi_cc(:,:,2) + popt_cloudsi_dc(:,:,1)*popt_cloudsi_dc(:,:,2)) &
+                             / (popt_cloudsi_cc(:,:,1) + popt_cloudsi_dc(:,:,1)))
+         where ((popt_cloudsi_cc(:,:,2).gt.0.0D0) .or. (popt_cloudsi_dc(:,:,2).gt.0.0D0))
+            popt_cloudsi(:,:,3) = (popt_cloudsi_cc(:,:,1)*popt_cloudsi_cc(:,:,2)*popt_cloudsi_cc(:,:,3) + popt_cloudsi_dc(:,:,1)*popt_cloudsi_dc(:,:,2)*popt_cloudsi_dc(:,:,3)) &
+                             / (popt_cloudsi_cc(:,:,1)*popt_cloudsi_cc(:,:,2) + popt_cloudsi_dc(:,:,1)*popt_cloudsi_dc(:,:,2))
+         elsewhere
+            popt_cloudsi(:,:,3) = 0.0D0
+         endwhere
 
          call sfluxi(plevrad,tlevrad,dtaui,taucumi,ubari,albi,      &
@@ -562,21 +739,71 @@
       !  Optical thickness diagnostics (added by JVO)
       if (diagdtau) then
-        do l=1,L_NLAYRAD
-          do nw=1,L_NSPECTV
-            int_dtauv(ig,l,nw) = 0.0d0
-             DO k=1,L_NGAUSS
-              ! Output exp(-tau) because gweight ponderates exp and not tau itself
-              int_dtauv(ig,l,nw)= int_dtauv(ig,l,nw) + exp(-dtauv(l,nw,k))*gweight(k)
-             ENDDO
-          enddo
-          do nw=1,L_NSPECTI
-           int_dtaui(ig,l,nw) = 0.0d0
-             DO k=1,L_NGAUSS
-              ! Output exp(-tau) because gweight ponderates exp and not tau itself
-              int_dtaui(ig,l,nw)= int_dtaui(ig,l,nw) + exp(-dtaui(l,nw,k))*gweight(k)
-             ENDDO
-          enddo
-        enddo
-      endif        
+         do l=1,L_NLAYRAD
+            do nw=1,L_NSPECTV
+               int_dtauv(ig,l,nw) = 0.0d0
+               DO k=1,L_NGAUSS
+               ! Output exp(-tau) because gweight ponderates exp and not tau itself
+               int_dtauv(ig,l,nw)= int_dtauv(ig,l,nw) + exp(-dtauv(l,nw,k))*gweight(k)
+               ENDDO
+            enddo
+            do nw=1,L_NSPECTI
+            int_dtaui(ig,l,nw) = 0.0d0
+               DO k=1,L_NGAUSS
+               ! Output exp(-tau) because gweight ponderates exp and not tau itself
+               int_dtaui(ig,l,nw)= int_dtaui(ig,l,nw) + exp(-dtaui(l,nw,k))*gweight(k)
+               ENDDO
+            enddo
+         enddo
+      endif
+      
+      
+      ! Optical properties of haze and clouds (dtau, tau, k, w, g) :
+      do l = 2, L_LEVELS, 2
+         lev2lay = L_NLAYRAD+1 - l/2
+         
+         ! Visible :
+         do nw = 1, L_NSPECTV
+            popthv(ig,lev2lay,nw,:) = 0.0d0
+            poptcv(ig,lev2lay,nw,:) = 0.0d0
+            ! Optical thickness (dtau) :
+            popthv(ig,lev2lay,nw,1) = (popt_hazev(l,nw,1) + popt_hazev(l+1,nw,1)) / 2.0
+            poptcv(ig,lev2lay,nw,1) = (popt_cloudsv(l,nw,1) + popt_cloudsv(l+1,nw,1)) / 2.0
+            ! Opacity (tau) :
+            do k = L_NLAYRAD, lev2lay, -1
+               popthv(ig,lev2lay,nw,2) = popthv(ig,lev2lay,nw,2) + popthv(ig,k,nw,1)
+               poptcv(ig,lev2lay,nw,2) = poptcv(ig,lev2lay,nw,2) + poptcv(ig,k,nw,1)
+            enddo
+            ! Extinction (k) :
+            popthv(ig,lev2lay,nw,3) = popthv(ig,lev2lay,nw,1) / (zzlev(ig,lev2lay+1) - zzlev(ig,lev2lay))
+            poptcv(ig,lev2lay,nw,3) = poptcv(ig,lev2lay,nw,1) / (zzlev(ig,lev2lay+1) - zzlev(ig,lev2lay))
+            ! Simple Scattering Albedo (w) and Asymmetry Parameter (g) :
+            popthv(ig,lev2lay,nw,4) = (popt_hazev(l,nw,2) + popt_hazev(l+1,nw,2)) / 2.0
+            poptcv(ig,lev2lay,nw,4) = (popt_cloudsv(l,nw,2) + popt_cloudsv(l+1,nw,2)) / 2.0
+            popthv(ig,lev2lay,nw,5) = (popt_hazev(l,nw,3) + popt_hazev(l+1,nw,3)) / 2.0
+            poptcv(ig,lev2lay,nw,5) = (popt_cloudsv(l,nw,3) + popt_cloudsv(l+1,nw,3)) / 2.0         
+         enddo
+
+         ! Infra-Red
+         do nw=1,L_NSPECTI
+            popthi(ig,lev2lay,nw,:) = 0.0d0
+            poptci(ig,lev2lay,nw,:) = 0.0d0
+            ! Optical thickness (dtau) :
+            popthi(ig,lev2lay,nw,1) = (popt_hazei(l,nw,1) + popt_hazei(l+1,nw,1)) / 2.0
+            poptci(ig,lev2lay,nw,1) = (popt_cloudsi(l,nw,1) + popt_cloudsi(l+1,nw,1)) / 2.0
+            ! Opacity (tau) :
+            do k = L_NLAYRAD, lev2lay, -1
+               popthi(ig,lev2lay,nw,2) = popthi(ig,lev2lay,nw,2) + popthi(ig,k,nw,1)
+               poptci(ig,lev2lay,nw,2) = poptci(ig,lev2lay,nw,2) + poptci(ig,k,nw,1)
+            enddo
+            ! Extinction (k) :
+            popthi(ig,lev2lay,nw,3) = popthi(ig,lev2lay,nw,1) / (zzlev(ig,lev2lay+1) - zzlev(ig,lev2lay))
+            poptci(ig,lev2lay,nw,3) = poptci(ig,lev2lay,nw,1) / (zzlev(ig,lev2lay+1) - zzlev(ig,lev2lay))
+            ! Simple Scattering Albedo (w) and Asymmetry Parameter (g) :
+            popthi(ig,lev2lay,nw,4) = (popt_hazei(l,nw,2) + popt_hazei(l+1,nw,2)) / 2.0
+            poptci(ig,lev2lay,nw,4) = (popt_cloudsi(l,nw,2) + popt_cloudsi(l+1,nw,2)) / 2.0
+            popthi(ig,lev2lay,nw,5) = (popt_hazei(l,nw,3) + popt_hazei(l+1,nw,3)) / 2.0
+            poptci(ig,lev2lay,nw,5) = (popt_cloudsi(l,nw,3) + popt_cloudsi(l+1,nw,3)) / 2.0
+         enddo
+      enddo
 
 
Index: trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90	(revision 3083)
@@ -45,5 +45,20 @@
       logical,save :: eff_gz
 !$OMP THREADPRIVATE(eff_gz)
-      
+
+      logical,save :: nudging_u
+!$OMP THREADPRIVATE(nudging_u)
+      real,save    :: nudging_dt
+!$OMP THREADPRIVATE(nudging_dt)
+
+      logical,save :: opt4clouds
+!$OMP THREADPRIVATE(opt4clouds)
+      real,save    :: Fcloudy
+      real,save    :: Fssa
+      real,save    :: FHVIS
+      real,save    :: FHIR
+!$OMP THREADPRIVATE(Fcloudy,Fssa,FHVIS,FHIR)
+      logical,save :: resCH4_inf
+!$OMP THREADPRIVATE(resCH4_inf)
+       
       integer,save :: ichim
 !$OMP THREADPRIVATE(ichim)
Index: trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90	(revision 3083)
@@ -18,5 +18,5 @@
   !! done elsewhere.
   !! 
-  !! Authors : J.Burgalat, J.Vatant d'Ollone - 2017
+  !! Authors : J.Burgalat, J.Vatant d'Ollone - 2017, B. de Batz de Trenquelléon (2023)
   !!
   USE MMP_GCM
@@ -61,4 +61,5 @@
 
   REAL(kind=8), DIMENSION(:,:), ALLOCATABLE ::  int2ext !! (\(m^{-2}\)).
+  REAL(kind=8), DIMENSION(:), ALLOCATABLE   :: tmp 
   TYPE(error) :: err
 
@@ -131,12 +132,18 @@
       m3n(:) = zq(ilon,:,6) * int2ext(ilon,:)
       do i=1,nices
-        m3i(:,nices) = zq(ilon,:,6+i) * int2ext(ilon,:)
-        gazs(:,i)    = zq(ilon,:,ices_indx(i)) / rat_mmol(ices_indx(i)) ! For gazs we work on the full tracer array !!
+        m3i(:,i)  = zq(ilon,:,ices_indx(i)) * int2ext(ilon,:)
+        gazs(:,i) = zq(ilon,:,gazs_indx(i)) / rat_mmol(gazs_indx(i)) ! For gazs we work on the full tracer array !!
         ! We use the molar mass ratio from GCM in case there is discrepancy with the mm one
       enddo
     endif
 
+    ! Hackin the pressure level
+    tmp = plev(ilon,:)
+    if (tmp(nlay+1) == 0.0) then
+      tmp(nlay+1) = 2*tmp(nlay) - tmp(nlay-1)
+    endif
+
     ! Initialize YAMMS atmospheric column
-    err = mm_column_init(plev(ilon,:),zlev(ilon,:),play(ilon,:),zlay(ilon,:),temp(ilon,:)) ; IF (err /= 0) call abort_program(err)
+    err = mm_column_init(tmp,zlev(ilon,:),play(ilon,:),zlay(ilon,:),temp(ilon,:)) ; IF (err /= 0) call abort_program(err)
     ! Initialize YAMMS aerosols moments column
     err = mm_aerosols_init(m0as,m3as,m0af,m3af) ; IF (err /= 0) call abort_program(err)
@@ -148,11 +155,8 @@
 
     ! initializes tendencies:
-    !dm0as(:) = 0._mm_wp ; dm3as(:) = 0._mm_wp ; dm0af(:) = 0._mm_wp ; dm3af(:) = 0._mm_wp
-    !dm0n(:) = 0._mm_wp ; dm3n(:) = 0._mm_wp ; dm3i(:,:) = 0._mm_wp ; dgazs(:,:) = 0._mm_wp
-
-    dm0as(:) = 0.D0 ; dm3as(:) = 0.D0 ; dm0af(:) = 0.D0 ; dm3af(:) = 0.D0
-    dm0n(:) = 0.D0 ; dm3n(:) = 0.D0 ; dm3i(:,:) = 0.D0 ; dgazs(:,:) = 0.D0
+    dm0as(:) = 0._mm_wp ; dm3as(:) = 0._mm_wp ; dm0af(:) = 0._mm_wp ; dm3af(:) = 0._mm_wp
+    dm0n(:) = 0._mm_wp ; dm3n(:) = 0._mm_wp ; dm3i(:,:) = 0._mm_wp ; dgazs(:,:) = 0._mm_wp
+    
     ! call microphysics
-
     IF (callclouds) THEN ! call clouds
       IF(.NOT.mm_muphys(dm0as,dm3as,dm0af,dm3af,dm0n,dm3n,dm3i,dgazs)) &
@@ -163,6 +167,6 @@
     ENDIF
     ! save diags (if no clouds, relevant arrays will be set to 0 !)
-    call mm_diagnostics(mmd_aer_prec(ilon),mmd_aer_s_flux(ilon,:),mmd_aer_f_flux(ilon,:),  &
-                        mmd_ccn_prec(ilon),mmd_ccn_flux(ilon,:), mmd_ice_prec(ilon,:),   &
+    call mm_diagnostics(mmd_aer_prec(ilon),mmd_aer_s_w(ilon,:),mmd_aer_f_w(ilon,:),mmd_aer_s_flux(ilon,:),mmd_aer_f_flux(ilon,:),  &
+                        mmd_ccn_prec(ilon),mmd_ccn_w(ilon,:),mmd_ccn_flux(ilon,:),mmd_ice_prec(ilon,:),   &
                         mmd_ice_fluxes(ilon,:,:),mmd_gazs_sat(ilon,:,:))
     call mm_get_radii(mmd_rc_sph(ilon,:),mmd_rc_fra(ilon,:),mmd_rc_cld(ilon,:))
@@ -180,6 +184,6 @@
       zdq(ilon,:,6) = dm3n(:) / int2ext(ilon,:)
       do i=1,nices
-        zdq(ilon,:,6+i) = dm3i(:,nices) / int2ext(ilon,:)
-        zdq(ilon,:,ices_indx(i)) = dgazs(:,i) * rat_mmol(ices_indx(i)) ! For gazs we work on the full tracer array !!
+        zdq(ilon,:,ices_indx(i)) = dm3i(:,i) / int2ext(ilon,:)
+        zdq(ilon,:,gazs_indx(i)) = dgazs(:,i) * rat_mmol(gazs_indx(i)) ! For gazs we work on the full tracer array !!
         ! We use the molar mass ratio from GCM in case there is discrepancy with the mm one
       enddo
Index: trunk/LMDZ.TITAN/libf/phytitan/cond_muphy.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/cond_muphy.F90	(revision 3083)
+++ trunk/LMDZ.TITAN/libf/phytitan/cond_muphy.F90	(revision 3083)
@@ -0,0 +1,83 @@
+subroutine cond_muphy(ngrid,nlayer,pt,dqmuficond,dtlc)
+
+use comcstfi_mod, only: cpp ! Heat capacity of the atmosphere [J.kg-1.K-1]
+use tracer_h
+
+implicit none
+
+!====================================================================
+!
+!   Purpose
+!   -------
+!   The routine calculates the latent heat 
+!   from condensation of species from microphysics
+!   
+!   INPUT
+!   -----
+!   ngrid      = Number of grid points in the chunk [-]
+!   nlayer     = Number of vertical layers [-]
+!   pt         = Temperature [K]
+!   dqmuficond = Trend of gas condensed in the microphysics [kg.kg_air-1.s-1]
+!
+!   OUTPUT
+!   ------
+!   dtlc = Condensation heating rate [K.s-1]
+!
+!   Author(s)
+!   ---------
+!   B. de Batz de Trenquelléon (07/2023)
+!====================================================================    
+
+
+!------------------------------------
+! 0. DECLARATIONS
+!------------------------------------
+
+! Inputs :
+!---------
+integer, intent(in) :: ngrid
+integer, intent(in) :: nlayer
+real, intent(in)    :: pt(ngrid,nlayer)
+real, intent(in)    :: dqmuficond(ngrid,nlayer,size(ices_indx))
+
+! Outputs :
+!----------
+real, intent(out) :: dtlc(ngrid,nlayer)
+
+! Local variables :
+!------------------
+integer :: iq
+real*8  :: Lc(ngrid,nlayer,size(ices_indx)) ! Condensation latente heat [J.kg-1]
+
+
+!------------------------------------
+! 1. INITIALISATION
+!------------------------------------
+
+! Variables set to 0 :
+! ~~~~~~~~~~~~~~~~~~~~
+dtlc(:,:) = 0.0D0
+Lc(:,:,:) = 0.0D0
+
+
+! Computes Lc for ices [J.kg-1] :
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+call calc_condlh(ngrid,nlayer,pt,Lc)
+
+
+! Sum of condensation latent heat [J.kg_air-1.s-1] :
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+do iq = 1, size(ices_indx)
+    dtlc(:,:) = dtlc(:,:) + (dqmuficond(:,:,iq) * Lc(:,:,iq))
+enddo
+
+
+! Condensation heating rate :
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~
+! If ice formation  : dqmuficond > 0 --> dtlc > 0
+! Else vaporisation : dqmuficond < 0 --> dtlc < 0
+dtlc(:,:) = dtlc(:,:) / cpp ! [K.s-1]
+
+return
+
+end subroutine cond_muphy
Index: trunk/LMDZ.TITAN/libf/phytitan/datafile_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/datafile_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/datafile_mod.F90	(revision 3083)
@@ -27,6 +27,11 @@
       ! Default file for coupled microphysics optical properties
       ! Set in physiq_mod
-      character(LEN=100),save :: haze_opt_file ='datagcm/HAZE_OPT_23x23.DAT'
+      character(LEN=100),save :: haze_opt_file ='datagcm/optical_tables/HAZE_OPT_23x23.DAT'
 !$OMP THREADPRIVATE(haze_opt_file)
+
+      ! Default file for nudging of zonal wind
+      ! Set in physiq_mod
+      character(LEN=100),save :: nudging_file ='datagcm/SuperNudging.dat'
+!$OMP THREADPRIVATE(nudging_file)
 
       end module datafile_mod
Index: trunk/LMDZ.TITAN/libf/phytitan/disr_haze.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/disr_haze.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/disr_haze.F90	(revision 3083)
@@ -45,5 +45,5 @@
 ! wl_PL in nm
 ! press_PL in Pa
-   open(11,file=TRIM(datadir)//'/hazetable_PL_original.dat',status="old",iostat=ierr)
+   open(11,file=TRIM(datadir)//'/optical_tables/hazetable_PL_original.dat',status="old",iostat=ierr)
    read(11,*) dummy,wl_PL
    do i=1,nblev_PL
